# Helper methods to recursively modify Hash objects
# @author nredmond@masteryconnect.com
module RecursiveHashUtils
  # Recursively convert all string keys in a Hash to symbol keys. Will recurse 
  # through nested Hash and Array objects.
  def self.convert_string_keys_to_symbols hash
    s2s = lambda do |h|
      if Hash === h
        Hash[
          h.map do |k, v|
            [k.respond_to?(:to_sym) ? k.to_sym : k, s2s[v]]
          end
        ]
      elsif Array === h
        hash_array = []
        h.each do |val|
          hash_array.push s2s[val]
        end

        hash_array
      else
        h
      end
    end

    s2s[hash]
  end
end